"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const hash_1 = __importDefault(require("@amaui/utils/hash"));
const merge_1 = __importDefault(require("@amaui/utils/merge"));
const style_1 = require("@amaui/style");
const _1 = require(".");
function inline(value_, props, options_ = { response: 'json' }) {
    const [value, setValue] = react_1.default.useState(undefined);
    const amauiStyle = (0, _1.useAmauiStyle)();
    const amauiTheme = (0, _1.useAmauiTheme)();
    const update = (update_ = true) => {
        const options = (0, merge_1.default)(options_, { amaui_style: { value: amauiStyle }, amaui_theme: { value: amauiTheme } }, { copy: true });
        // Options response value
        options.response = 'json';
        const valueNew = (0, style_1.inline)(value_, props, options);
        if (update_)
            setValue(valueNew);
        return valueNew;
    };
    // Update
    react_1.default.useEffect(() => {
        update();
        if (amauiTheme)
            amauiTheme.subscriptions.update.subscribe(update);
        // Clean up
        return () => {
            // Unsubscribe
            if (amauiTheme)
                amauiTheme.subscriptions.update.unsubscribe(update);
        };
    }, []);
    // Update props
    react_1.default.useEffect(() => {
        update();
    }, [(0, hash_1.default)(props)]);
    // Important for ssr value
    const value__ = value || update(false);
    return value__;
}
exports.default = inline;
